﻿using System;

using OpenPop.Mime;
using OpenPop.Pop3;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 메시지 노드 쓰기 - WriteMessageNode(messageNode, nodeLevel)

        /// <summary>
        /// 메시지 노드 쓰기
        /// </summary>
        /// <param name="messageNode">메시지 노드</param>
        /// <param name="nodeLevel">노드 레벨</param>
        private static void WriteMessageNode(MessageNode messageNode, int nodeLevel = 0)
        {
            Console.WriteLine($"{" ".PadRight(nodeLevel * 4)}{messageNode.NodeName}");

            foreach(MessageNode childNode in messageNode.ChildNodeList)
            {
                WriteMessageNode(childNode, nodeLevel + 1);
            }
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            string hostName = "pop.naver.com";
            int    port     = 995;
            bool   useSSL   = true;
            string userName = "tester";
            string password = "1234";

            using(Pop3Client client = new Pop3Client())
            {
                client.Connect(hostName, port, useSSL);

                client.Authenticate(userName, password);

                int messageCount = client.GetMessageCount();

                for(int i = 1; i <= messageCount; i++)
                {
                    Message message = client.GetMessage(i);

                    MessageTraverser traverser = new MessageTraverser();

                    MessageNode node = traverser.VisitMessage(message);

                    WriteMessageNode(node);

                    Console.WriteLine();
                }
            }
        }

        #endregion
    }
}